<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: FeedController.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Controller
 * @subpackage Default
 * @copyright  Copyright (c) 2012 VEC
 */

class FeedController extends Zend_Controller_Action
{

    public function rssAction ()
    {
        $layout = Zend_Layout::getMvcInstance();
        if ($layout instanceof Zend_Layout) {
            $layout->disableLayout();
        }
        $this->_helper->viewRenderer->setNoRender();
        
        $translate = Zend_Registry::get('Zend_Translate');
        
        //Get request data
        $lang = Zend_Registry::get('Zend_Translate')->getLocale();
        
        //News
        $newsTable = new Giscuit_Db_Table_News();
        $rows = $newsTable->getItems(array(
            'withDesc' => true , 
            'withTitle' => true , 
            'whereActive' => 't'
        ));
        
        if (count($rows) == 0) {
            $lastUpdate = time();
        } else {
            $lastUpdate = strtotime($rows[0]->created_date);
        }
        
        $feedArray = array(
            'title' => $translate->_('pageTitle') , 
            'link' => $this->_helper->url->url(array(
                'language' => Zend_Registry::get('Zend_Translate')->getLocale() , 
                'module' => 'default'
            ), null, true) , 
            'description' => $translate->_('pageDescription') , 
            'language' => $lang , 
            'charset' => 'utf-8' , 
            'lastUpdate' => $lastUpdate , 
            'generator' => 'Zend_Feed' , 
            'entries' => array()
        );
        
        if (count($rows) > 0) {
            foreach ($rows as $row) {
                $feedArray['entries'][] = array(
                    'title' => $row->title , 
                    'link' => $this->_helper->url->url(array(
                        'language' => Zend_Registry::get('Zend_Translate')->getLocale() , 
                        'module' => 'default' , 
                        'controller' => 'news' , 
                        'action' => 'detailed' , 
                        'id' => $row->id
                    ), null, true) , 
                    'guid' => $row->id , 
                    'description' => $row->desc , 
                    'lastUpdate' => strtotime($row->created_date)
                );
            }
        }
        
        $feed = Zend_Feed::importArray($feedArray, 'rss');
        
        if (headers_sent()) {
            echo $feed->saveXml();    
        } else {
            $feed->send();
        }
    
    }

}