<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id$
 * @category   Giscuit
 * @package    Giscuit_Controller
 * @subpackage Mobile
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Tool_PrivatelayersController
 */
require_once GT_MODULES_PATH . DIR_SEP . 'tool' . DIR_SEP . 'controllers' . DIR_SEP . 'PrivatelayersController.php';

class Mobile_PrivatelayersController extends Tool_PrivatelayersController
{
    public function getSettingsForm ()
    {
        $form = new Giscuit_Form_PrivatelayersSettings();
        
        $action = $this->_helper->url->url(array(
            'language' => Zend_Registry::get('Zend_Translate')->getLocale() ,
            'module' => 'mobile' ,
            'controller' => 'privatelayers' ,
            'action' => 'settings' ,
            'id' => $this->_request->getParam('id')
        ), null, true);
        $form->setAction($action);
        
        //
        $form->applyJqmFixes();
        
        //Color
        $form->removeElement('signup');
        $form->addElement('text', 'label_color', array(
            'validators' => array(
                'Color'
            ) , 
            'required' => false , 
            'label' => 'color' , 
        ));
        
        //Back
        $form->removeElement('back_button');
        
        //View
        $form->removeElement('view');
        
        return $form;
    }
    
    public function settingsbulkAction ()
    {
        /*
        //Update cache
        Zend_Registry::get('settings')->offlineTimestamp = time();
        */
        
        $result['replyCode'] = 200;
        
        $data = Zend_Json::decode($this->_request->getParam('data'));
        if(empty($data)) {
            $this->_helper->json($result);
        }
        
        $layerSettingsTable = new Giscuit_Db_Table_LayerSettings();
        
        $form = new Giscuit_Form_PrivatelayersSettings();
        $userId = Zend_Controller_Action_HelperBroker::getStaticHelper('userId')->direct();

        foreach ($data as $params) {
            $form->populate($params);

            if ($form->isValid($params)) {
                $layerSettingsTable->editItem(intval($params['id']), $form);
                $layerSettingsTable->update(array('order' => intval($params['order'])), "layer_id = " . 
                    intval($params['id']) . " AND user_id = {$userId}");
            }
        } 
        
        $this->_helper->json($result);
    }

}