<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: CommForm.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Helper
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see  Zend_Controller_Action_Helper_Abstract
 */
require_once 'Zend/Controller/Action/Helper/Abstract.php';

/**
 * Returns a form object used for posting comments
 * 
 * @category   Giscuit
 * @package    Giscuit_Helper
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Controller_Action_Helper_CommForm extends Zend_Controller_Action_Helper_Abstract
{

    /*
    public $pluginLoader;

    public function __construct()
    {
        $this->pluginLoader = new Zend_Loader_PluginLoader();
    }
    */
    
    /**
     * Returns a form object used for posting comments
     * 
     * @param array $options Available options
     * @return Zend_Form
     */
    public function commForm ($options = null)
    {
        $url = Zend_Controller_Action_HelperBroker::getStaticHelper('url');
        
        $auth = Zend_Auth::getInstance();
        
        $form = new Giscuit_Form_Comm();
        $form->setMethod('post');
        $form->addAttribs(array(
            'id' => 'commForm' , 
            'action' => $url->url(array(
                'language' => Zend_Registry::get('Zend_Translate')->getLocale(), 
                'module' => 'default' ,
                'controller' => 'comm' , 
                'action' => 'submit' , 
                'location' => $options['location'] , 
                'part' => $options['part']
            ), null, true)
        ));
        
        return $form;
    }

    /**
     * Strategy pattern: call helper as helper broker method
     * 
     * Returns a form object used for posting comments
     * 
     * @param array $options Available options
     * @return Zend_Form
     */
    public function direct ($options = null)
    {
        return $this->commForm($options);
    }

}