<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: UserId.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Helper
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see  Zend_Controller_Action_Helper_Abstract
 */
require_once 'Zend/Controller/Action/Helper/Abstract.php';

/**
 * Get current user id
 * 
 * @category   Giscuit
 * @package    Giscuit_Helper
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Controller_Action_Helper_UserId extends Zend_Controller_Action_Helper_Abstract
{

    /*
    public $pluginLoader;

    public function __construct()
    {
        $this->pluginLoader = new Zend_Loader_PluginLoader();
    }
    */
    
    /**
     * Get current user id
     * 
     * @param array $options Available options
     * @return integer|bool
     */
    public function userId ($options = null)
    {
        $auth = Zend_Auth::getInstance();
        
        if ($auth->hasIdentity() && ! empty($auth->getIdentity()->id)) {
            return $auth->getIdentity()->id;
        } else {
            return false;
        }
    
    }

    /**
     * Strategy pattern: call helper as helper broker method
     * 
     * Get current user id
     *  
     * @param array $options Available options
     * @return integer|bool
     */
    public function direct ($options = null)
    {
        return $this->userId($options);
    }
}