<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: Articles.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Form
 * @subpackage Admin
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Zend_Form
 */
require_once 'Zend/Form.php';

/**
 * Article form class
 * 
 * @category   Giscuit
 * @package    Giscuit_Form
 * @subpackage Admin
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Form_Admin_Articles extends Giscuit_Form_Abstract
{
    /**
     * Initialize
     *
     * @return void
     */
    public function init ()
    {
        $languages = Zend_Registry::get('config')->language->toArray();
        
        foreach ($languages as $key => $language) {
            
            $this->addElement('text', 'title_' . $key, array(
                'filters' => array() , 
                'validators' => array(
                    array(
                        'StringLength' , 
                        false , 
                        3
                    )
                ) , 
                'required' => false , 
                'label' => 'title'
            ));
            
            $this->addElement('text', 'tags_' . $key, array(
                'filters' => array() , 
                'validators' => array(
                    array(
                        'StringLength' , 
                        false , 
                        3
                    )
                ) , 
                'required' => false , 
                'label' => 'tags'
            ));
            
            $this->addElement('textarea', 'desc_' . $key, array(
                'filters' => array() , 
                'validators' => array(
                    array(
                        'StringLength' , 
                        false , 
                        3
                    )
                ) , 
                'required' => false , 
                'label' => 'desc' , 
                'rows' => 5
            ));
            
            $this->addElement('textarea', 'text_' . $key, array(
                'filters' => array() , 
                'validators' => array(
                    array(
                        'StringLength' , 
                        false , 
                        3
                    )
                ) , 
                'required' => false , 
                'label' => 'text' , 
                'rows' => 5
            ));
        }
        
        $this->addElement('checkbox', 'active', array(
            'filters' => array() , 
            'validators' => array(
                array(
                    'InArray' , 
                    false , 
                    array(
                        array(
                            't' , 
                            'f'
                        )
                    )
                )
            ) , 
            'required' => true , 
            'label' => 'active' , 
            'checkedValue' => 't' ,
            'uncheckedValue' => 'f'
        ));
        
        $this->addElement('text', 'created_date', array(
            'filters' => array() , 
            'validators' => array(
                array(
                    'Date' , 
                    false , 
                    array(
                        'yyyy-MM-dd'
                    )
                )
            ) , 
            'required' => false
        ));
        
        //Image
        /*
        $image = new Zend_Form_Element_File('image');
        
        //Generate image file name
        if (! empty($_FILES['image']['name'])) {
            $imageFileName = md5(rand()) . '_' . $_FILES['image']['name'];
            $image->addFilter('Rename', GT_TMP_PATH . '/' . $imageFileName);
            Zend_Registry::set('ArticlesImageName', $imageFileName);
        }
        
        $image->setLabel('uploadAnImage')->addPrefixPath('Zend_Filter_File', 'Zend/Filter/File', 'filter')->setDestination(GT_TMP_PATH)->addValidator('Count', false, 1)->addValidator('FilesSize', false, array(
            '10kB' , 
            '2MB'
        ))->addValidator('Extension', false, 'jpg,png,gif');
        
        $this->addElement($image, 'image');
        */
        
        $this->addElement('button', 'submit_button', array(
            'required' => false , 
            'ignore' => true , 
            'label' => 'submit' ,
            'id' => 'submit_button' , 
            /*
            'decorators' => array(
                'ViewHelper'
            )
            */
        ));
        
        $this->addDecorators(array(
            array(
                'viewScript' , 
                array(
                    'viewScript' => 'forms' . DIR_SEP . 'articles' . GT_SCRIPT_EXT
                )
            )
        ));
        
        $this->setAttrib('enctype', 'multipart/form-data');
    }

}