<?php
/**
 * Giscuit
 *
 * @version    $Id: DatabaseAdd.php 2929 2012-08-13 11:41:08Z vlad.bruma $
 * @category   Giscuit
 * @package    Giscuit_Form
 * @subpackage Admin
 * @copyright  Copyright (c) 2012 VEC
 *
 */

/**
 * @see Zend_Form
 */
require_once 'Zend/Form.php';

/**
 * Add database table form class
 * 
 * @category   Giscuit
 * @package    Giscuit_Form
 * @subpackage Admin
 * @copyright  Copyright (c) 2012 VEC
 *
 */
class Giscuit_Form_Admin_DatabaseAdd extends Giscuit_Form_Abstract
{
    /**
     * Initialize
     *
     * @return void
     */
    public function init ()
    {
        $translate = Zend_Registry::get('Zend_Translate');
        
        //Name
        $this->addElement('text', 'name', array(
            'filters' => array(
                'StringToLower'
            ) , 
            'validators' => array(
                array(
                    'StringLength' , 
                    false , 
                    3
                ) , 
                array(
                    'TablenameAvailable'
                ),
                new Zend_Validate_Regex('/^([0-9a-z_])+$/i')
            ) , 
            'required' => true , 
            'label' => 'name' ,
            'order' => 1
        ));
        
        //Method
        $this->addElement('radio', 'type', array(
            'label' => 'type' , 
            'value' => 2 ,
            'multiOptions' => array(
                1 => $translate->_('noGeom') ,
                2 => $translate->_('Point') , 
                3 => $translate->_('Line') , 
                4 => $translate->_('Polygon') ,
            ) ,
            'order' => 2
        ));

        //
        $editingPlugin = Zend_Controller_Front::getInstance()->getPlugin('Giscuit_Controller_Plugin_Editing');
        if ($editingPlugin != false) {
            $editingPlugin->adminDatabaseForm($this);
        }

    }
}
?>