<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: Chpass.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Form
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Giscuit_Form_Abstract
 */
require_once 'Giscuit/Form/Abstract.php';

/**
 * Form class for password change 
 * 
 * @category   Giscuit
 * @package    Giscuit_Form
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Form_Chpass extends Giscuit_Form_Abstract
{
    /**
     * Initialize
     *
     * @return void
     */
    public function init ()
    {
        
        //Set method and id
        $this->setMethod('post');
        $this->addAttribs(array(
            'id' => 'gtChpassForm'
        ));
        
        //Old password
        $this->addElement('password', 'oldpassword', array(
            'validators' => array(
                'Oldpassword'
            ) , 
            'required' => true , 
            'label' => 'oldpassword'
        ));
        
        //Password
        $this->addElement('password', 'password', array(
            'validators' => array(
                array(
                    'StringLength' , 
                    false , 
                    array(
                        6 , 
                        20
                    )
                )
            ) , 
            'required' => true , 
            'label' => 'password'
        ));
        
        //Confirm password
        $this->addElement('password', 'confirm_password', array(
            'validators' => array(
                array(
                    'ConfirmPassword' , 
                    false , 
                    array(
                        'password'
                    )
                )
            ) , 
            'required' => true , 
            'label' => 'confirm_password'
        ));
        
        //Submit
        $this->addElement('button', 'submit_button', array(
            'attribs' => array(
                'id' => 'gtChpassSubmit'
            ) , 
            'required' => false , 
            'ignore' => true , 
            'label' => 'changePassword'
        ));
    
    }
}