<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: RastercutManage.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Form
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Giscuit_Form_Abstract
 */
require_once 'Giscuit/Form/Abstract.php';

/**
 * Download raster statistics form class
 * 
 * @category   Giscuit
 * @package    Giscuit_Form
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Form_RastercutManage extends Giscuit_Form_Abstract
{
    /**
     * Initialize
     *
     * @return void
     */
    public function init ()
    {
        $settings = Zend_Registry::get('settings');
        $config = Zend_Registry::get('config');

        //Date begin
        if(!empty($settings->rastercutDateBegin)) {
            $dateBeginValue = $settings->rastercutDateBegin;
        } else {
            $date = new Zend_Date();
            $dateBeginValue = $date->toString(GT_DATE_STYLE_PHP);
        }
        $this->addElement('text', 'dateBegin', array(
            'filters' => array(
                'StringTrim'
            ) , 
            'validators' => array(
                array(
                    'Date' , 
                    false , 
                    array(
                        'yyyy-MM-dd'
                    )
                )
            ) , 
            'required' => false , 
            'label' => 'dateBegin' , 
            'attribs' => array(
                'id' => 'gtRastercutDateBeginId'
            ) ,
            'value' => $dateBeginValue
        ));
        
        //Date end
         if(!empty($settings->rastercutDateEnd)) {
            $dateEndValue = $settings->rastercutDateEnd;
        } else {
            $dateEndValue = NULL;
        }
        $this->addElement('text', 'dateEnd', array(
            'filters' => array(
                'StringTrim'
            ) , 
            'validators' => array(
                array(
                    'Date' , 
                    false , 
                    array(
                        'yyyy-MM-dd'
                    )
                )
            ) , 
            'required' => false , 
            'label' => 'dateEnd' , 
            'attribs' => array(
                'id' => 'gtRastercutDateEndId'
            ) ,
            'value' => $dateEndValue
        ));
        
        //Submit
        $this->addElement('button', 'submit', array(
            'required' => false , 
            'ignore' => true , 
            'label' => 'submit' , 
            'attribs' => array(
                'id' => 'gtRastercutManageSubmit'
            ) ,
            'decorators' => array(
                'ViewHelper'
            )
        ));
        
        //Clear
        $this->addElement('button', 'clear', array(
            'required' => false , 
            'ignore' => true , 
            'label' => 'clear' , 
            'attribs' => array(
                'id' => 'gtRastercutManageClear'
            ) ,
            'decorators' => array(
                'ViewHelper'
            )
        ));

    }
}