/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this package in the file LICENSE.txt.
 *
 * @version    $Id: Zoomregion.js 2536 2012-04-12 21:23:20Z pavel.iacovlev $
 * @copyright  Copyright (c) 2012 VEC
 */
Giscuit.Map.prototype.gtEventListeners.push({
    'draw': function() {
        gt.control.zoomregion = new Giscuit.Control.Zoomregion();
    }
});

/**
 * Class: Giscuit.Control.Zoomregion
 * 
 *  Inherits from:
 *   - <Giscuit.Control>
 */
Giscuit.Control.Zoomregion = OpenLayers.Class(OpenLayers.Control.ZoomBox, {
    
    active: false,
    
    button: null,
    
    initialize: function (options) {
        Giscuit.Control.prototype.initialize.apply(this, [options]);
        
        var self = this;
        
        this.button = new YAHOO.widget.Button({ 
            label: gt.map.getControlIcon(24), 
            id: "gtControlZoomregion", 
            onclick: {fn: function() {
                if(self.active) {
                    self.deactivate();
                } else {
                    self.activate();
                }
            }},
            title: gt.translate._('zoomregion'), 
            container: "gtMapControls",
            type: 'checkbox'
        });
        
        gt.map.addControl(this);
    },
    
    activate: function () {
        gt.map.deactivateAll();

        var activated = Giscuit.Control.prototype.activate.call(this);
        if (activated == true) {
            //Check button
            this.button.set('checked', true);
        }

        return activated;
    },

    deactivate: function () {
        var deactivated = Giscuit.Control.prototype.deactivate.call(this);
        if (deactivated == true) {
            //Uncheck button
            this.button.set('checked', false);
        }
                
        return deactivated;
    },

    
    
    CLASS_NAME: "Giscuit.Control.Zoomregion"
});